from Module import Module
from parse_config_file import get_bar_config_and_module_config_list
#from threading import Thread
#from subprocess import run
#from time import sleep
#from config_parsing import get_validated_config, parse_module
#
#running_modules_dict = {"left": {}, "center": {}, "right": {}}
#
#def print_bar():
#    for alignment in running_modules_dict:
#        match alignment:
#            case "left":
#                print("%{l}" + margin, end="")
#            case "center":
#                print("%{c}", end="")
#            case "right":
#                print("%{r}", end="")
#        # convert group to list so we can access subsequent items
#        group = list(running_modules_dict[alignment].values())
#        for index, module in enumerate(group):
#            print(module, end="")
#            # IF module is not the last AND it has text
#            if index != (len(group) - 1) and len(module) > 0:
#                # THEN only print seperator if the module is eventually followed
#                # by a module with text
#                for i in range(index + 1, len(group)):
#                    if len(group[i]) > 0:
#                        print(seperator, end="")
#                        break;
#        if alignment == "right":
#            print(margin, end="")
#
#    print(flush=True)
#
#def create_module_string(pre, prefix, command, post):
#        cmd_output = run(command, shell=True, capture_output=True, text=True).stdout.strip()
#        if cmd_output != "":
#            return (pre + padding + prefix + cmd_output + padding + post)
#        else:
#            return cmd_output
#    
#
#def new_module_thread(alignment, pre, name, prefix, command, post, refresh):
#    running_modules_dict[alignment][name] = ""
#    while True:
#        module_string = create_module_string(pre, prefix, command, post)
#        running_modules_dict[alignment][name] = module_string
#        print_bar()
#        if refresh == 0:
#            break
#        sleep(refresh/1000)


def main():
    bar_config, module_config_list = get_bar_config_and_module_config_list("/home/noah/src/easyconf-lemonbar/data/testing_config.yml")
    padding = bar_config["padding"]
    left_modules = []
    center_modules = []
    right_modules = []

    for module_config in module_config_list:
        module = Module(module_config, padding)
        match module.alignment:
            case "left":
                left_modules.append(module)
            case "center":
                center_modules.append(module)
            case "right":
                right_modules.append(module)
        module.start_thread()



if __name__ == "__main__":
    main()
